
#define XS 320
#define YS 200
#define STEP 3

void blox(unsigned char *buf,int size,int mul,int plus)
{
    int sum,num,x,y,mx,my,tmp;

    for(my=0;my<YS;my+=size)
        for(mx=0;mx<XS;mx+=size)
        {
            /* Sum the elements of a block */
            sum=num=0;
            for(y=my;y<size+my;y+=STEP)
            {
                if(y>=YS)
                    break;
                for(x=mx;x<size+mx;x+=STEP)
                {
                    sum+=buf[y*XS+x];
                    num++;
                }
            }

            sum=(sum*mul)/255/num+plus; /* The average of the block */

            for(y=my;y<size+my;y++) /* Blend the average in */
            {
                if(y>=YS)
                    break;
                for(x=mx;x<size+mx;x++)
                {
                    tmp=buf[y*XS+x]+sum;
                    if(tmp>255)
                        tmp=255;
                    buf[y*XS+x]=tmp;
                }
            }
        }
}
